using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls;
namespace DragAndDrop
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor propertyEditor1;
		private Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView paletteGroupView1;
		private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
		}

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);

			this.LoadSymbolPalette();			
		}

		// Create a SymbolModel for the custom MySymbol and add it to the PaletteGroupView control
		protected void LoadSymbolPalette()
		{
			// Create a SymbolPalette for the PaletteGroupView control
			this.paletteGroupView1.Palette = new SymbolPalette();

			// Initialize a SymbolModel for the custom Symbol class
			SymbolModel mysymbolmodel = this.paletteGroupView1.Palette.AddSymbol("MySymbol");
			mysymbolmodel.PlugInClass = "DragAndDrop.MySymbol";
			mysymbolmodel.PlugInAssembly = typeof(Form1).Assembly.FullName;
			mysymbolmodel.SmallIcon = new Bitmap("..\\..\\res\\symbol_small.bmp");
			mysymbolmodel.LargeIcon = new Bitmap("..\\..\\res\\symbol_large.bmp");

			// Create a PaletteGroupView item to represent the SymbolModel and add it to the PaletteGroupView
			int imageIdx = 0;
			int lgImageIdx = 0;
			int smImageIdx = 0;
			if (mysymbolmodel.SmallIcon != null)
				smImageIdx = this.paletteGroupView1.AddSmallIcon(mysymbolmodel.SmallIcon);
			if (mysymbolmodel.LargeIcon != null)
				lgImageIdx = this.paletteGroupView1.AddLargeIcon(mysymbolmodel.LargeIcon);

			if(this.paletteGroupView1.SmallImageView)
				imageIdx = smImageIdx;
			else
				imageIdx = lgImageIdx;

			Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView.GroupViewPaletteItem gvItem = 
				new PaletteGroupView.GroupViewPaletteItem(mysymbolmodel, imageIdx);
			this.paletteGroupView1.GroupViewItems.Add(gvItem);
		}
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.propertyEditor1 = new Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor();
			this.diagram1 = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram();
			this.paletteGroupView1 = new Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView();
			((System.ComponentModel.ISupportInitialize)(this.diagram1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.diagram1.Model)).BeginInit();
			this.SuspendLayout();
			// 
			// propertyEditor1
			// 
			this.propertyEditor1.Diagram = this.diagram1;
			this.propertyEditor1.Dock = System.Windows.Forms.DockStyle.Right;
			this.propertyEditor1.Location = new System.Drawing.Point(528, 0);
			this.propertyEditor1.Name = "propertyEditor1";
			this.propertyEditor1.Size = new System.Drawing.Size(160, 454);
			this.propertyEditor1.TabIndex = 1;
			// 
			// diagram1
			// 
			this.diagram1.AllowDrop = true;
			// 
			// diagram1.Controller
			// 
			this.diagram1.Controller.MaxHistory = 256;
			this.diagram1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.diagram1.HScroll = true;
			this.diagram1.LayoutManager = null;
			this.diagram1.Location = new System.Drawing.Point(104, 0);
			// 
			// diagram1.Model
			// 
			this.diagram1.Model.Height = 1056.792F;
			this.diagram1.Model.LineBridgeSize = 0.1666667F;
			this.diagram1.Model.LineStyle.LineWidth = 0.02083333F;
			this.diagram1.Model.MeasurementUnits = System.Drawing.GraphicsUnit.Inch;
			this.diagram1.Model.Name = "Model";
			this.diagram1.Model.ShadowStyle.OffsetX = 0.0625F;
			this.diagram1.Model.ShadowStyle.OffsetY = 0.0625F;
			this.diagram1.Model.Width = 856.6325F;
			this.diagram1.Name = "diagram1";
			this.diagram1.Size = new System.Drawing.Size(424, 454);
			this.diagram1.SmartSizeBox = false;
			this.diagram1.TabIndex = 3;
			this.diagram1.Text = "diagram1";
			// 
			// diagram1.View
			// 
			this.diagram1.View.Grid.DashOffset = 0.04166667F;
			this.diagram1.View.Grid.HorizontalSpacing = 0.1041667F;
			this.diagram1.View.Grid.VerticalSpacing = 0.1041667F;
			this.diagram1.View.Grid.Visible = false;
			this.diagram1.VScroll = true;
			this.diagram1.DragEnter += new System.Windows.Forms.DragEventHandler(this.diagram1_DragEnter);
			this.diagram1.DragDrop += new System.Windows.Forms.DragEventHandler(this.diagram1_DragDrop);
			// 
			// paletteGroupView1
			// 
			this.paletteGroupView1.ButtonView = true;
			this.paletteGroupView1.Dock = System.Windows.Forms.DockStyle.Left;
			this.paletteGroupView1.Location = new System.Drawing.Point(0, 0);
			this.paletteGroupView1.Name = "paletteGroupView1";
			this.paletteGroupView1.Size = new System.Drawing.Size(104, 454);
			this.paletteGroupView1.TabIndex = 2;
			this.paletteGroupView1.Text = "paletteGroupView1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(688, 454);
			this.Controls.Add(this.diagram1);
			this.Controls.Add(this.paletteGroupView1);
			this.Controls.Add(this.propertyEditor1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.diagram1.Model)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.diagram1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void diagram1_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			Point pt = this.diagram1.PointToClient(new Point(e.X, e.Y));
			if (e.Data.GetDataPresent(typeof(DragDropData)))
			{				
				e.Effect = DragDropEffects.All;
			}
		}

		private void diagram1_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			//Allow Drop Cursor only if it is a Diagram Node of MySymbol type
			if ( (e.Data.GetDataPresent(typeof(DragDropData))))
			{
				e.Effect = DragDropEffects.All;
			}
			else
				e.Effect = DragDropEffects.None;
		
		}

	}
}
