#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.ComponentModel;
using System.Runtime.Serialization;

using Syncfusion.Windows.Forms.Diagram;

namespace DragAndDrop
{
	/// <summary>
	/// Summary description for MySymbol.
	/// </summary>
	[Serializable()]
	public class MySymbol : Symbol
	{
		private Syncfusion.Windows.Forms.Diagram.Rectangle outerRect = null;
		private Ellipse innerEllipse = null;
		private int curEllipseColor = 0;
		private string strDescription = "Custom Symbol";

		static System.Drawing.Color[] ellipseColors =
		{
			Color.AliceBlue,
			Color.DeepSkyBlue,
			Color.LightBlue,
			Color.Aquamarine
		};

		public MySymbol()
		{
			//////////////////////////////////////////////////////////////////
			// Add child nodes to the symbol programmatically
			//////////////////////////////////////////////////////////////////

			// Add an outer rectangle
			this.outerRect = new Syncfusion.Windows.Forms.Diagram.Rectangle(0, 0, 120, 80);
			this.outerRect.Name = "Rectangle";
			this.outerRect.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyleType.LinearGradient;
			this.outerRect.FillStyle.ForeColor = System.Drawing.Color.Orange;
			this.outerRect.FillStyle.Color = Color.Orange;
			this.outerRect.ShadowStyle.Visible = true;
			this.AppendChild(outerRect);

			// Add an inner ellipse
			this.innerEllipse = new Ellipse(10, 10, 100, 60);
			this.innerEllipse.Name = "Ellipse";
			this.innerEllipse.FillStyle.Color = ellipseColors[this.curEllipseColor];
			this.AppendChild(innerEllipse);

			Label lbl = this.AddLabel("Hello World", BoxPosition.Center);
			lbl.BackgroundStyle.Color = Color.Transparent;
			lbl.ReadOnly = false;
		}
	
	}
}
